#                             Scramdisk for Linux
#                             ===================
#
#  $Id: scramdisk.spec,v 1.3 2005/08/12 09:34:34 huj Exp $
#  Author: Hans-Ulrich Juettner
#  Copyright (c) 2005 - Hans-Ulrich Juettner
#
#  Scramdisk for Linux is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License as
#  published by the Free Software Foundation; either version 2 of the
#  License, or (at your option) any later version.
#
#  Scramdisk for Linux is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#  General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Scramdisk for Linux -- see the file COPYING. If not,
#  write to the Free Software Foundation, Inc., 59 Temple Place,
#  Suite 330, Boston, MA 02111-1307, USA.
#
#  Scramdisk for Linux is a Windows container-compatible on-the-fly
#  encryption system.  For details, see the Scramdisk World-Wide-Web page,
#  `http://www.samsimpson.com/cryptography/scramdisk/', or send a mail to
#  the Scramdisk for Linux developer <hans-ulrich.juettner@t-online.de>.
#
#  $Log: scramdisk.spec,v $
#  Revision 1.3  2005/08/12 09:34:34  huj
#  Source renamed
#
#  Revision 1.2  2005/08/11 20:49:28  huj
#  Changes for installation on Debian
#
#  Revision 1.1  2005/05/22 20:10:22  huj
#  First public version 0.8.2
#

%define kernel_fullver %(bash -c 'uname -r')
%define kernel_ver %(bash -c 'uname -r | cut -d- -f1')
%define extradir %(bash -c 'if [ `uname -r | cut -d. -f2` == "4" ]; then echo misc; else echo extra; fi')
%define object %(bash -c 'if [ `uname -r | cut -d. -f2` == "4" ]; then echo scramdisk.o; else echo scramdisk.ko; fi')

Name: Scramdisk
Summary: An on-the-fly encryption system compatible with Scramdisk for Windows
Version: 0.8
Release: 3
Requires: kernel-default = %{kernel_ver}, qt3 >= 3.2.1
License: GPL
Group: System/Cryptography
Source: %{name}-%{version}.tar.gz
BuildRoot: %{_tmppath}/build-root-%{name}
Packager: Hans-Ulrich Juettner
Url: http://www.scramdisklinux.org/

%description
Scramdisk for Linux is an on-the-fly encryption system which hides
complete file systems within encrypted regular files called containers.
If configured accordingly it is container-compatible with
Scramdisk for Windows developed by Shaun Hollingworth.

%prep

%setup

%build
make

%install
export BASE_DIR=$RPM_BUILD_DIR/%{name}-%{version}

export KERNEL_VER=`uname -r`
if [ `uname -r | cut -d. -f2` == "4" ]; then
  export EXTRADIR=misc
  export OBJECT=scramdisk.o
else
  export EXTRADIR=extra
  export OBJECT=scramdisk.ko
fi

export SDBIN="$RPM_BUILD_ROOT/usr/bin"
export SDETC="$RPM_BUILD_ROOT/etc/scramdisk"
export SDSHARE="$RPM_BUILD_ROOT/usr/share/scramdisk"
export SDDOC="$RPM_BUILD_ROOT/usr/share/doc/scramdisk"
export SDINIT="$RPM_BUILD_ROOT/etc/init.d"
export SDBOOT="$RPM_BUILD_ROOT/etc/init.d/boot.d"
export SDLIB="$RPM_BUILD_ROOT/lib/modules/$KERNEL_VER/$EXTRADIR"

export SDDIRS="$SDBIN $SDETC $SDSHARE $SDDOC $SDINIT $SDBOOT $SDLIB"

for d in $SDDIRS; do
  if [ ! -d "$d" ]; then
    mkdir -p "$d"
    if [ ! -d "$d" ]; then
      echo "Error: unable to create directory $d"
      exit 1
    else
      chmod 0755 "$d" > /dev/null
    fi
  fi
done

strip "$BASE_DIR/gui/scramdisk"
strip "$BASE_DIR/utils/sdchange"
strip "$BASE_DIR/utils/sdcreate"
strip "$BASE_DIR/utils/sdmount"
strip "$BASE_DIR/utils/sdumount"

install -m 0644 "$BASE_DIR/driver/$OBJECT" "$SDLIB"
install -m 0644 "$BASE_DIR/utils/scramdiskrc" "$SDETC"
install -m 0755 "$BASE_DIR/utils/scramdisk.init" "$SDINIT/boot.scramdisk"
install -m 0755 "$BASE_DIR/utils/sdchange" "$SDBIN"
install -m 4755 "$BASE_DIR/utils/sdcreate" "$SDBIN"
install -m 4755 "$BASE_DIR/utils/sdmount" "$SDBIN"
install -m 4755 "$BASE_DIR/utils/sdumount" "$SDBIN"
install -m 4755 "$BASE_DIR/gui/scramdisk" "$SDBIN"
install -m 0644 "$BASE_DIR/gui/change.png" "$SDSHARE"
install -m 0644 "$BASE_DIR/gui/create.png" "$SDSHARE"
install -m 0644 "$BASE_DIR/gui/mount.png" "$SDSHARE"
install -m 0644 "$BASE_DIR/gui/umount.png" "$SDSHARE"
install -m 0644 "$BASE_DIR/gui/scramdisk.png" "$SDSHARE"
install -m 0644 "$BASE_DIR/docs/gui.jpg" "$SDSHARE"
install -m 0644 "$BASE_DIR/docs/create.jpg" "$SDSHARE"
install -m 0644 "$BASE_DIR/docs/ppdialog.jpg" "$SDSHARE"
install -m 0644 "$BASE_DIR/docs/config.jpg" "$SDSHARE"
install -m 0644 "$BASE_DIR/docs/index.html" "$SDSHARE"
install -m 0644 "$BASE_DIR/docs/intro.html" "$SDSHARE"
install -m 0644 "$BASE_DIR/docs/mount.html" "$SDSHARE"
install -m 0644 "$BASE_DIR/docs/create.html" "$SDSHARE"
install -m 0644 "$BASE_DIR/docs/change.html" "$SDSHARE"
install -m 0644 "$BASE_DIR/docs/config.html" "$SDSHARE"
install -m 0644 "$BASE_DIR/docs/scramdisk.pdf" "$SDDOC"

%clean
make clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{name}-%{version}
exit 0

%files
%defattr(-,root,root)

%dir %attr(0755,root,root) /etc/scramdisk
%dir %attr(0755,root,root) /usr/share/scramdisk
%dir %attr(0755,root,root) /usr/share/doc/scramdisk
%attr(4755,root,root) /usr/bin/scramdisk
%attr(0755,root,root) /usr/bin/sdchange
%attr(4755,root,root) /usr/bin/sdcreate
%attr(4755,root,root) /usr/bin/sdmount
%attr(4755,root,root) /usr/bin/sdumount
%attr(0644,root,root) /lib/modules/%{kernel_fullver}/%{extradir}/%{object}
%attr(0755,root,root) /etc/init.d/boot.scramdisk
%attr(0644,root,root) /usr/share/scramdisk/*.html
%attr(0644,root,root) /usr/share/scramdisk/*.jpg
%attr(0644,root,root) /usr/share/scramdisk/*.png
%doc %attr(0644,root,root) /usr/share/doc/scramdisk/scramdisk.pdf
%config %attr(0644,root,root) /etc/scramdisk/scramdiskrc

%post
depmod -F /boot/System.map-%{kernel_fullver}
if [ -d /etc/init.d/boot.d ]; then
  cd /etc/init.d/boot.d
  ln -s ../boot.scramdisk S80boot.scramdisk
  ln -s ../boot.scramdisk K04boot.scramdisk
fi
mkdir -p /dev/scramdisk
if [ -d /dev/scramdisk ]; then
  mknod /dev/scramdisk/master b 125 0
  mknod /dev/scramdisk/vol01 b 125 1
  mknod /dev/scramdisk/vol02 b 125 2
  mknod /dev/scramdisk/vol03 b 125 3
  mknod /dev/scramdisk/vol04 b 125 4
  mknod /dev/scramdisk/vol05 b 125 5
  mknod /dev/scramdisk/vol06 b 125 6
  mknod /dev/scramdisk/vol07 b 125 7
  mknod /dev/scramdisk/vol08 b 125 8
  mknod /dev/scramdisk/vol09 b 125 9
  mknod /dev/scramdisk/vol10 b 125 10
  mknod /dev/scramdisk/vol11 b 125 11
  mknod /dev/scramdisk/vol12 b 125 12
  mknod /dev/scramdisk/vol13 b 125 13
  mknod /dev/scramdisk/vol14 b 125 14
  mknod /dev/scramdisk/vol15 b 125 15
else
  echo "Error: unable to create directory /dev/scramdisk"
  exit 1
fi
exit 0

%postun
depmod -F /boot/System.map-%{kernel_fullver}
exit 0

%preun
rm -f /etc/init.d/boot.d/S80boot.scramdisk
rm -f /etc/init.d/boot.d/K04boot.scramdisk
rm -rf /dev/scramdisk
exit 0
