/*                             Scramdisk for Linux
 *                             ===================
 *
 *  $Id: sdmnt.h,v 1.2 2005/08/11 20:49:32 huj Exp $
 *  Author: Hans-Ulrich Juettner
 *  Copyright (c) 2005 - Hans-Ulrich Juettner
 *
 *  Scramdisk for Linux is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, or (at your option) any later version.
 *
 *  Scramdisk for Linux is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Scramdisk for Linux -- see the file COPYING. If not,
 *  write to the Free Software Foundation, Inc., 59 Temple Place,
 *  Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Scramdisk for Linux is a Windows container-compatible on-the-fly
 *  encryption system.  For details, see the Scramdisk World-Wide-Web page,
 *  `http://www.samsimpson.com/cryptography/scramdisk/', or send a mail to
 *  the Scramdisk for Linux developer <hans-ulrich.juettner@t-online.de>.
 *
 *  $Log: sdmnt.h,v $
 *  Revision 1.2  2005/08/11 20:49:32  huj
 *  Changes for installation on Debian
 *
 *  Revision 1.1  2005/05/22 20:10:23  huj
 *  First public version 0.8.2
 *
 */

#ifndef SD_SDMNT_H
#define SD_SDMNT_H

#include "sdmount.h"

#ifndef _PATH_MOUNTED
#define _PATH_MOUNTED "/etc/mtab" 
#endif
#define MOUNTED_TMP _PATH_MOUNTED ".tmp"

enum MntAction { Mnt, UMnt, TmpMnt };

class SdMount
{
  private:
    bool good;
    bool mounted;
    MntAction action;
    sd_mount_t sd_mount;

  public:
    SdMount(MntAction ma);
    ~SdMount();
    void SetReadOnly(int rdonly = 1) { sd_mount.rd_only = rdonly; }
    bool Good() { return good; }
    bool ReadOnly() { return sd_mount.rd_only != 0; }
    char* Filename() { return sd_mount.filename; }
    char* MountPoint() { return sd_mount.mnt_point; }
    cipher_id CphrId() { return sd_mount.cphr_id; }
    digest_id DgstId() { return sd_mount.dgst_id; }
    unsigned int Size() { return sd_mount.size; }
    void SetPhrase(const octet* phrase, size_t size);
    int Mount();
    bool UMount();
};

#endif
